src/MyVod/Controllers/CheckoutController.cs
using Microsoft.AspNetCore.Mvc;
using MyVod.Models;
using MyVod.Services;

namespace MyVod.Controllers;

public class CheckoutController : Controller
{
    private readonly IMovieService _movieService;

    public CheckoutController(IMovieService movieService)
    {
        _movieService = movieService;
    }
    
    [HttpGet("/checkout/{movieId:guid}")]
    public async Task<IActionResult> Index(Guid movieId)
    {
        var movie = await _movieService.Get(movieId);

        var checkoutModel = new CheckoutViewModel
        {
            Movie = movie,
            Tax = 23
        };
        
        return View(checkoutModel);
    }
}

src/MyVod/Controllers/HomeController.cs
using System.Diagnostics;
using Microsoft.AspNetCore.Mvc;
using MyVod.Domain;
using MyVod.Domain.Library.Domain;
using MyVod.Domain.SharedKernel;
using MyVod.Models;
using MyVod.Services;

namespace MyVod.Controllers;

public class HomeController : Controller
{
    private readonly ILogger<HomeController> _logger;
    private readonly IMovieService _movieService;
    private readonly Domain.Library.Application.IMovieService _newMovieService;

    public HomeController(ILogger<HomeController> logger,
        IMovieService movieService,
        Domain.Library.Application.IMovieService newMovieService)
    {
        _logger = logger;
        _movieService = movieService;
        _newMovieService = newMovieService;
    }

    public async Task<IActionResult> Index()
    {
        var movies = await _movieService.GetLive();
        return View(movies);
    }

    public IActionResult Privacy()
    {
        return View();
    }

    [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
    public IActionResult Error()
    {
        return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
    }

    [HttpGet("/test/{id:guid}")]
    public async Task<IActionResult> Test(MovieId id)
    {
        var movie = await _newMovieService.Get(id);

        return Json(movie);
    }
}

src/MyVod/Controllers/MoviesController.cs
using Microsoft.AspNetCore.Mvc;
using MyVod.Infrastructure.Models;
using MyVod.Services;

namespace MyVod.Controllers;

public class MoviesController : Controller
{
    private readonly IMovieService _movieService;

    public MoviesController(IMovieService movieService)
    {
        _movieService = movieService;
    }

    [HttpGet("[controller]/{id:guid}")]
    [ActionName("")]
    public async Task<IActionResult> Index(Guid id)
    {
        var movie = await _movieService.Get(id);   
        return View("Index", movie);
    }
}

src/MyVod/Views/Home/Index.cshtml
@model IEnumerable<MyVod.Infrastructure.Models.Movie>

@{
    ViewData["Title"] = "Home Page";
}

<h2 class="page-header">Best Movies!</h2>

<section class="movie-section">
    <div class="row row-cols-1 row-cols-md-4 g-4">
         @foreach (var movie in Model)
    {
        <div class="col">
            <div class="card h-100">
                <img class="card-img-top" src="@movie.Cover" alt="Card image cap">
                <div class="card-body">
                    <h5 class="card-title">
                        <a asp-area="" asp-controller="Movies" asp-action="" asp-route-id="@movie.Id">@movie.Title (@movie.EnglishTitle)</a>
                    </h5>
                </div>
                <div class="card-footer">Price: @((double)movie.Price/100)$ <a asp-area="" asp-controller="Checkout" asp-action="Index" asp-route-movieId="@movie.Id" class="btn btn-outline-success">Buy</a></div>
            </div>
        </div>
    }
    </div>
</section>

